diff --git a/gcc/ipa-cp.c b/gcc/ipa-cp.c
index 48521cf..49be835 100644
--- a/gcc/ipa-cp.c
+++ b/gcc/ipa-cp.c
@@ -3629,32 +3629,64 @@ cgraph_gate_cp (void)
   return flag_ipa_cp && optimize;
 }
 
-struct ipa_opt_pass_d pass_ipa_cp =
-{
- {
-  IPA_PASS,
-  "cp",				/* name */
-  OPTGROUP_NONE,                /* optinfo_flags */
-  cgraph_gate_cp,		/* gate */
-  ipcp_driver,			/* execute */
-  NULL,				/* sub */
-  NULL,				/* next */
-  0,				/* static_pass_number */
-  TV_IPA_CONSTANT_PROP,		/* tv_id */
-  0,				/* properties_required */
-  0,				/* properties_provided */
-  0,				/* properties_destroyed */
-  0,				/* todo_flags_start */
-  TODO_dump_symtab |
-  TODO_remove_functions         /* todo_flags_finish */
- },
- ipcp_generate_summary,			/* generate_summary */
- ipcp_write_summary,			/* write_summary */
- ipcp_read_summary,			/* read_summary */
- ipa_prop_write_all_agg_replacement,	/* write_optimization_summary */
- ipa_prop_read_all_agg_replacement,	/* read_optimization_summary */
- NULL,			 		/* stmt_fixup */
- 0,					/* TODOs */
- ipcp_transform_function,		/* function_transform */
- NULL,					/* variable_transform */
-};
+class pass_ipa_cp : public ipa_opt_pass_d
+{
+public:
+  pass_ipa_cp(context &ctxt)
+    : ipa_opt_pass_d(ctxt,
+		     "cp",
+		     OPTGROUP_NONE,
+		     TV_IPA_CONSTANT_PROP,
+		     pass_properties(required(0),
+				     provided(0),
+				     destroyed(0)),
+		     pass_todo_flags(start(0),
+				     finish(TODO_dump_symtab | TODO_remove_functions)),
+		     0) /* function_transform_todo_flags_start */
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return cgraph_gate_cp (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return ipcp_driver (); }
+
+  /* ipa_opt_pass_d methods: */
+  bool has_generate_summary () { return true; }
+  void impl_generate_summary () { ipcp_generate_summary (); }
+
+  bool has_write_summary () { return true; }
+  void impl_write_summary () { ipcp_write_summary (); }
+
+  bool has_read_summary () { return true; }
+  void impl_read_summary () { ipcp_read_summary (); }
+
+  bool has_write_optimization_summary () { return true; }
+  void impl_write_optimization_summary () {
+    ipa_prop_write_all_agg_replacement ();
+  }
+
+  bool has_read_optimization_summary () { return true; }
+  void impl_read_optimization_summary () {
+    ipa_prop_read_all_agg_replacement ();
+  }
+
+  bool has_stmt_fixup () { return false; }
+  void impl_stmt_fixup (struct cgraph_node *, gimple *) { }
+
+  bool has_function_transform () { return true; }
+  unsigned int impl_function_transform (struct cgraph_node *node) {
+    return ipcp_transform_function (node);
+  }
+
+  bool has_variable_transform () { return false; }
+  void impl_variable_transform (struct varpool_node *) { }
+
+}; // class pass_ipa_cp
+
+ipa_opt_pass_d *
+make_pass_ipa_cp (context &ctxt)
+{
+  return new pass_ipa_cp (ctxt);
+}
diff --git a/gcc/ipa-inline-analysis.c b/gcc/ipa-inline-analysis.c
index 138433c..7d09f56 100644
--- a/gcc/ipa-inline-analysis.c
+++ b/gcc/ipa-inline-analysis.c
@@ -2713,25 +2713,37 @@ compute_inline_parameters_for_current (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_inline_parameters = 
-{
- {
-  GIMPLE_PASS,
-  "inline_param",		/* name */
-  OPTGROUP_INLINE,		/* optinfo_flags */
-  NULL,			/* gate */
-  compute_inline_parameters_for_current,	/* execute */
-  NULL,			/* sub */
-  NULL,			/* next */
-  0,				/* static_pass_number */
-  TV_INLINE_PARAMETERS,	/* tv_id */
-  0,				/* properties_required */
-  0,				/* properties_provided */
-  0,				/* properties_destroyed */
-  0,				/* todo_flags_start */
-  0				/* todo_flags_finish */
+class pass_inline_parameters : public gimple_opt_pass
+{
+public:
+  pass_inline_parameters(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "inline_param",
+		      OPTGROUP_INLINE,
+		      TV_INLINE_PARAMETERS,
+		      pass_properties(required(0),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return compute_inline_parameters_for_current ();
   }
-};
+
+}; // class pass_inline_parameters
+
+gimple_opt_pass *
+make_pass_inline_parameters (context &ctxt)
+{
+  return new pass_inline_parameters (ctxt);
+}
 
 
 /* Estimate benefit devirtualizing indirect edge IE, provided KNOWN_VALS and
diff --git a/gcc/ipa-inline.c b/gcc/ipa-inline.c
index 964d1f9..8b65867 100644
--- a/gcc/ipa-inline.c
+++ b/gcc/ipa-inline.c
@@ -2073,25 +2073,35 @@ early_inliner (void)
   return todo;
 }
 
-struct gimple_opt_pass pass_early_inline =
+class pass_early_inline : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "einline",	 			/* name */
-  OPTGROUP_INLINE,                      /* optinfo_flags */
-  NULL,					/* gate */
-  early_inliner,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_EARLY_INLINING,			/* tv_id */
-  PROP_ssa,                             /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                 			/* todo_flags_finish */
- }
-};
+public:
+  pass_early_inline(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "einline",
+		      OPTGROUP_INLINE,
+		      TV_EARLY_INLINING,
+		      pass_properties(required(PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return early_inliner (); }
+
+}; // class pass_early_inline
+
+gimple_opt_pass *
+make_pass_early_inline (context &ctxt)
+{
+  return new pass_early_inline (ctxt);
+}
 
 
 /* When to run IPA inlining.  Inlining of always-inline functions
@@ -2106,32 +2116,60 @@ gate_ipa_inline (void)
   return optimize || flag_lto || flag_wpa;
 }
 
-struct ipa_opt_pass_d pass_ipa_inline =
+class pass_ipa_inline : public ipa_opt_pass_d
 {
- {
-  IPA_PASS,
-  "inline",				/* name */
-  OPTGROUP_INLINE,                      /* optinfo_flags */
-  gate_ipa_inline,			/* gate */
-  ipa_inline,				/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_IPA_INLINING,      		/* tv_id */
-  0,	                                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  TODO_remove_functions,		/* todo_flags_finish */
-  TODO_dump_symtab 
-  | TODO_remove_functions		/* todo_flags_finish */
- },
- inline_generate_summary,		/* generate_summary */
- inline_write_summary,			/* write_summary */
- inline_read_summary,			/* read_summary */
- NULL,					/* write_optimization_summary */
- NULL,					/* read_optimization_summary */
- NULL,					/* stmt_fixup */
- 0,					/* TODOs */
- inline_transform,			/* function_transform */
- NULL,					/* variable_transform */
-};
+public:
+  pass_ipa_inline(context &ctxt)
+    : ipa_opt_pass_d(ctxt,
+		     "inline",
+		     OPTGROUP_INLINE,
+		     TV_IPA_INLINING,
+		     pass_properties(required(0),
+				     provided(0),
+				     destroyed(0)),
+		     pass_todo_flags(start(TODO_remove_functions),
+				     finish(TODO_dump_symtab | TODO_remove_functions)),
+		     0) /* function_transform_todo_flags_start */
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_ipa_inline (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return ipa_inline (); }
+
+  /* ipa_opt_pass_d methods: */
+  bool has_generate_summary () { return true; }
+  void impl_generate_summary () { inline_generate_summary (); }
+
+  bool has_write_summary () { return true; }
+  void impl_write_summary () { inline_write_summary (); }
+
+  bool has_read_summary () { return true; }
+  void impl_read_summary () { inline_read_summary (); }
+
+  bool has_write_optimization_summary () { return false; }
+  void impl_write_optimization_summary () { }
+
+  bool has_read_optimization_summary () { return false; }
+  void impl_read_optimization_summary () { }
+
+  bool has_stmt_fixup () { return false; }
+  void impl_stmt_fixup (struct cgraph_node *, gimple *) { }
+
+  bool has_function_transform () { return true; }
+  unsigned int impl_function_transform (struct cgraph_node *node) {
+    return inline_transform (node);
+  }
+
+  bool has_variable_transform () { return false; }
+  void impl_variable_transform (struct varpool_node *) { }
+
+}; // class pass_ipa_inline
+
+ipa_opt_pass_d *
+make_pass_ipa_inline (context &ctxt)
+{
+  return new pass_ipa_inline (ctxt);
+}
diff --git a/gcc/ipa-pure-const.c b/gcc/ipa-pure-const.c
index 94c7315..822d4eb 100644
--- a/gcc/ipa-pure-const.c
+++ b/gcc/ipa-pure-const.c
@@ -1495,34 +1495,61 @@ gate_pure_const (void)
 	  && !seen_error ());
 }
 
-struct ipa_opt_pass_d pass_ipa_pure_const =
+class pass_ipa_pure_const : public ipa_opt_pass_d
 {
- {
-  IPA_PASS,
-  "pure-const",		                /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_pure_const,			/* gate */
-  propagate,			        /* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_IPA_PURE_CONST,		        /* tv_id */
-  0,	                                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                                     /* todo_flags_finish */
- },
- generate_summary,		        /* generate_summary */
- pure_const_write_summary,		/* write_summary */
- pure_const_read_summary,		/* read_summary */
- NULL,					/* write_optimization_summary */
- NULL,					/* read_optimization_summary */
- NULL,					/* stmt_fixup */
- 0,					/* TODOs */
- NULL,			                /* function_transform */
- NULL					/* variable_transform */
-};
+public:
+  pass_ipa_pure_const(context &ctxt)
+    : ipa_opt_pass_d(ctxt,
+		     "pure-const",
+		     OPTGROUP_NONE,
+		     TV_IPA_PURE_CONST,
+		     pass_properties(required(0),
+				     provided(0),
+				     destroyed(0)),
+		     pass_todo_flags(start(0),
+				     finish(0)),
+		     0) /* function_transform_todo_flags_start */
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_pure_const (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return propagate (); }
+
+  /* ipa_opt_pass_d methods: */
+  bool has_generate_summary () { return true; }
+  void impl_generate_summary () { generate_summary (); }
+
+  bool has_write_summary () { return true; }
+  void impl_write_summary () { pure_const_write_summary (); }
+
+  bool has_read_summary () { return true; }
+  void impl_read_summary () { pure_const_read_summary (); }
+
+  bool has_write_optimization_summary () { return false; }
+  void impl_write_optimization_summary () { }
+
+  bool has_read_optimization_summary () { return false; }
+  void impl_read_optimization_summary () { }
+
+  bool has_stmt_fixup () { return false; }
+  void impl_stmt_fixup (struct cgraph_node *, gimple *) { }
+
+  bool has_function_transform () { return false; }
+  unsigned int impl_function_transform (struct cgraph_node *) { return 0; }
+
+  bool has_variable_transform () { return false; }
+  void impl_variable_transform (struct varpool_node *) { }
+
+}; // class pass_ipa_pure_const
+
+ipa_opt_pass_d *
+make_pass_ipa_pure_const (context &ctxt)
+{
+  return new pass_ipa_pure_const (ctxt);
+}
 
 /* Return true if function should be skipped for local pure const analysis.  */
 
@@ -1661,22 +1688,32 @@ local_pure_const (void)
     return 0;
 }
 
-struct gimple_opt_pass pass_local_pure_const =
+class pass_local_pure_const : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "local-pure-const",	                /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_pure_const,			/* gate */
-  local_pure_const,		        /* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_IPA_PURE_CONST,		        /* tv_id */
-  0,	                                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_local_pure_const(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "local-pure-const",
+		      OPTGROUP_NONE,
+		      TV_IPA_PURE_CONST,
+		      pass_properties(required(0),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_pure_const (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return local_pure_const (); }
+
+}; // class pass_local_pure_const
+
+gimple_opt_pass *
+make_pass_local_pure_const (context &ctxt)
+{
+  return new pass_local_pure_const (ctxt);
+}
diff --git a/gcc/ipa-reference.c b/gcc/ipa-reference.c
index f3c483f..22fb85f 100644
--- a/gcc/ipa-reference.c
+++ b/gcc/ipa-reference.c
@@ -1155,31 +1155,62 @@ gate_reference (void)
 	  && !seen_error ());
 }
 
-struct ipa_opt_pass_d pass_ipa_reference =
+class pass_ipa_reference : public ipa_opt_pass_d
 {
- {
-  IPA_PASS,
-  "static-var",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_reference,			/* gate */
-  propagate,			        /* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_IPA_REFERENCE,		        /* tv_id */
-  0,	                                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                                     /* todo_flags_finish */
- },
- NULL,				        /* generate_summary */
- NULL,					/* write_summary */
- NULL,				 	/* read_summary */
- ipa_reference_write_optimization_summary,/* write_optimization_summary */
- ipa_reference_read_optimization_summary,/* read_optimization_summary */
- NULL,					/* stmt_fixup */
- 0,					/* TODOs */
- NULL,			                /* function_transform */
- NULL					/* variable_transform */
-};
+public:
+  pass_ipa_reference(context &ctxt)
+    : ipa_opt_pass_d(ctxt,
+		     "static-var",
+		     OPTGROUP_NONE,
+		     TV_IPA_REFERENCE,
+		     pass_properties(required(0),
+				     provided(0),
+				     destroyed(0)),
+		     pass_todo_flags(start(0),
+				     finish(0)),
+		     0) /* function_transform_todo_flags_start */
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_reference (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return propagate (); }
+
+  /* ipa_opt_pass_d methods: */
+  bool has_generate_summary () { return false; }
+  void impl_generate_summary () { }
+
+  bool has_write_summary () { return false; }
+  void impl_write_summary () { }
+
+  bool has_read_summary () { return false; }
+  void impl_read_summary () { }
+
+  bool has_write_optimization_summary () { return true; }
+  void impl_write_optimization_summary () {
+    ipa_reference_write_optimization_summary ();
+  }
+
+  bool has_read_optimization_summary () { return true; }
+  void impl_read_optimization_summary () {
+    ipa_reference_read_optimization_summary ();
+  }
+
+  bool has_stmt_fixup () { return false; }
+  void impl_stmt_fixup (struct cgraph_node *, gimple *) { }
+
+  bool has_function_transform () { return false; }
+  unsigned int impl_function_transform (struct cgraph_node *) { return 0; }
+
+  bool has_variable_transform () { return false; }
+  void impl_variable_transform (struct varpool_node *) { }
+
+}; // class pass_ipa_reference
+
+ipa_opt_pass_d *
+make_pass_ipa_reference (context &ctxt)
+{
+  return new pass_ipa_reference (ctxt);
+}
diff --git a/gcc/ipa-split.c b/gcc/ipa-split.c
index e7d469d..7682c83 100644
--- a/gcc/ipa-split.c
+++ b/gcc/ipa-split.c
@@ -1593,25 +1593,35 @@ gate_split_functions (void)
 	  && !profile_arc_flag && !flag_branch_probabilities);
 }
 
-struct gimple_opt_pass pass_split_functions =
+class pass_split_functions : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "fnsplit",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_split_functions,			/* gate */
-  execute_split_functions,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_IPA_FNSPLIT,			/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_all      			/* todo_flags_finish */
- }
-};
+public:
+  pass_split_functions(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "fnsplit",
+		      OPTGROUP_NONE,
+		      TV_IPA_FNSPLIT,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_all)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_split_functions (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_split_functions (); }
+
+}; // class pass_split_functions
+
+gimple_opt_pass *
+make_pass_split_functions (context &ctxt)
+{
+  return new pass_split_functions (ctxt);
+}
 
 /* Gate feedback driven function splitting pass.
    We don't need to split when profiling at all, we are producing
@@ -1635,22 +1645,34 @@ execute_feedback_split_functions (void)
   return retval;
 }
 
-struct gimple_opt_pass pass_feedback_split_functions =
+class pass_feedback_split_functions : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "feedback_fnsplit",			/* name */
-  OPTGROUP_NONE,                      /* optinfo_flags */
-  gate_feedback_split_functions,	/* gate */
-  execute_feedback_split_functions,	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_IPA_FNSPLIT,			/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_all      			/* todo_flags_finish */
- }
-};
+public:
+  pass_feedback_split_functions(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "feedback_fnsplit",
+		      OPTGROUP_NONE,
+		      TV_IPA_FNSPLIT,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_all)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_feedback_split_functions (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return execute_feedback_split_functions ();
+  }
+
+}; // class pass_feedback_split_functions
+
+gimple_opt_pass *
+make_pass_feedback_split_functions (context &ctxt)
+{
+  return new pass_feedback_split_functions (ctxt);
+}
diff --git a/gcc/ipa.c b/gcc/ipa.c
index cb7b6b5..c88e7e0 100644
--- a/gcc/ipa.c
+++ b/gcc/ipa.c
@@ -898,25 +898,37 @@ local_function_and_variable_visibility (void)
   return function_and_variable_visibility (flag_whole_program && !flag_lto);
 }
 
-struct simple_ipa_opt_pass pass_ipa_function_and_variable_visibility =
+class pass_ipa_function_and_variable_visibility : public simple_ipa_opt_pass
 {
- {
-  SIMPLE_IPA_PASS,
-  "visibility",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  local_function_and_variable_visibility,/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_CGRAPHOPT,				/* tv_id */
-  0,	                                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_remove_functions | TODO_dump_symtab /* todo_flags_finish */
- }
-};
+public:
+  pass_ipa_function_and_variable_visibility(context &ctxt)
+    : simple_ipa_opt_pass(ctxt,
+			  "visibility",
+			  OPTGROUP_NONE,
+			  TV_CGRAPHOPT,
+			  pass_properties(required(0),
+					  provided(0),
+					  destroyed(0)),
+			  pass_todo_flags(start(0),
+					  finish(TODO_remove_functions | TODO_dump_symtab)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return local_function_and_variable_visibility ();
+  }
+
+}; // class pass_ipa_function_and_variable_visibility
+
+simple_ipa_opt_pass *
+make_pass_ipa_function_and_variable_visibility (context &ctxt)
+{
+  return new pass_ipa_function_and_variable_visibility (ctxt);
+}
 
 /* Free inline summary.  */
 
@@ -927,25 +939,35 @@ free_inline_summary (void)
   return 0;
 }
 
-struct simple_ipa_opt_pass pass_ipa_free_inline_summary =
+class pass_ipa_free_inline_summary : public simple_ipa_opt_pass
 {
- {
-  SIMPLE_IPA_PASS,
-  "*free_inline_summary",		/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  free_inline_summary,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_IPA_FREE_INLINE_SUMMARY,		/* tv_id */
-  0,	                                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+public:
+  pass_ipa_free_inline_summary(context &ctxt)
+    : simple_ipa_opt_pass(ctxt,
+			  "*free_inline_summary",
+			  OPTGROUP_NONE,
+			  TV_IPA_FREE_INLINE_SUMMARY,
+			  pass_properties(required(0),
+					  provided(0),
+					  destroyed(0)),
+			  pass_todo_flags(start(0),
+					  finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return free_inline_summary (); }
+
+}; // class pass_ipa_free_inline_summary
+
+simple_ipa_opt_pass *
+make_pass_ipa_free_inline_summary (context &ctxt)
+{
+  return new pass_ipa_free_inline_summary (ctxt);
+}
 
 /* Do not re-run on ltrans stage.  */
 
@@ -966,34 +988,65 @@ whole_program_function_and_variable_visibility (void)
   return 0;
 }
 
-struct ipa_opt_pass_d pass_ipa_whole_program_visibility =
+class pass_ipa_whole_program_visibility : public ipa_opt_pass_d
 {
- {
-  IPA_PASS,
-  "whole-program",			/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_whole_program_function_and_variable_visibility,/* gate */
-  whole_program_function_and_variable_visibility,/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_CGRAPHOPT,				/* tv_id */
-  0,	                                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_remove_functions | TODO_dump_symtab /* todo_flags_finish */
- },
- NULL,					/* generate_summary */
- NULL,					/* write_summary */
- NULL,					/* read_summary */
- NULL,					/* write_optimization_summary */
- NULL,					/* read_optimization_summary */
- NULL,					/* stmt_fixup */
- 0,					/* TODOs */
- NULL,					/* function_transform */
- NULL,					/* variable_transform */
-};
+public:
+  pass_ipa_whole_program_visibility(context &ctxt)
+    : ipa_opt_pass_d(ctxt,
+		     "whole-program",
+		     OPTGROUP_NONE,
+		     TV_CGRAPHOPT,
+		     pass_properties(required(0),
+				     provided(0),
+				     destroyed(0)),
+		     pass_todo_flags(start(0),
+				     finish(TODO_remove_functions | TODO_dump_symtab)),
+		     0) /* function_transform_todo_flags_start */
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () {
+    return gate_whole_program_function_and_variable_visibility ();
+  }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return whole_program_function_and_variable_visibility ();
+  }
+
+  /* ipa_opt_pass_d methods: */
+  bool has_generate_summary () { return false; }
+  void impl_generate_summary () { }
+
+  bool has_write_summary () { return false; }
+  void impl_write_summary () { }
+
+  bool has_read_summary () { return false; }
+  void impl_read_summary () { }
+
+  bool has_write_optimization_summary () { return false; }
+  void impl_write_optimization_summary () { }
+
+  bool has_read_optimization_summary () { return false; }
+  void impl_read_optimization_summary () { }
+
+  bool has_stmt_fixup () { return false; }
+  void impl_stmt_fixup (struct cgraph_node *, gimple *) { }
+
+  bool has_function_transform () { return false; }
+  unsigned int impl_function_transform (struct cgraph_node *) { return 0; }
+
+  bool has_variable_transform () { return false; }
+  void impl_variable_transform (struct varpool_node *) { }
+
+}; // class pass_ipa_whole_program_visibility
+
+ipa_opt_pass_d *
+make_pass_ipa_whole_program_visibility (context &ctxt)
+{
+  return new pass_ipa_whole_program_visibility (ctxt);
+}
 
 /* Entry in the histogram.  */
 
@@ -1313,34 +1366,61 @@ gate_ipa_profile (void)
   return flag_ipa_profile;
 }
 
-struct ipa_opt_pass_d pass_ipa_profile =
+class pass_ipa_profile : public ipa_opt_pass_d
 {
- {
-  IPA_PASS,
-  "profile_estimate",			/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_ipa_profile,			/* gate */
-  ipa_profile,			        /* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_IPA_PROFILE,		        /* tv_id */
-  0,	                                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                                     /* todo_flags_finish */
- },
- ipa_profile_generate_summary,	        /* generate_summary */
- ipa_profile_write_summary,		/* write_summary */
- ipa_profile_read_summary,		/* read_summary */
- NULL,					/* write_optimization_summary */
- NULL,					/* read_optimization_summary */
- NULL,					/* stmt_fixup */
- 0,					/* TODOs */
- NULL,			                /* function_transform */
- NULL					/* variable_transform */
-};
+public:
+  pass_ipa_profile(context &ctxt)
+    : ipa_opt_pass_d(ctxt,
+		     "profile_estimate",
+		     OPTGROUP_NONE,
+		     TV_IPA_PROFILE,
+		     pass_properties(required(0),
+				     provided(0),
+				     destroyed(0)),
+		     pass_todo_flags(start(0),
+				     finish(0)),
+		     0) /* function_transform_todo_flags_start */
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_ipa_profile (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return ipa_profile (); }
+
+  /* ipa_opt_pass_d methods: */
+  bool has_generate_summary () { return true; }
+  void impl_generate_summary () { ipa_profile_generate_summary (); }
+
+  bool has_write_summary () { return true; }
+  void impl_write_summary () { ipa_profile_write_summary (); }
+
+  bool has_read_summary () { return true; }
+  void impl_read_summary () { ipa_profile_read_summary (); }
+
+  bool has_write_optimization_summary () { return false; }
+  void impl_write_optimization_summary () { }
+
+  bool has_read_optimization_summary () { return false; }
+  void impl_read_optimization_summary () { }
+
+  bool has_stmt_fixup () { return false; }
+  void impl_stmt_fixup (struct cgraph_node *, gimple *) { }
+
+  bool has_function_transform () { return false; }
+  unsigned int impl_function_transform (struct cgraph_node *) { return 0; }
+
+  bool has_variable_transform () { return false; }
+  void impl_variable_transform (struct varpool_node *) { }
+
+}; // class pass_ipa_profile
+
+ipa_opt_pass_d *
+make_pass_ipa_profile (context &ctxt)
+{
+  return new pass_ipa_profile (ctxt);
+}
 
 /* Generate and emit a static constructor or destructor.  WHICH must
    be one of 'I' (for a constructor) or 'D' (for a destructor).  BODY
@@ -1624,31 +1704,58 @@ gate_ipa_cdtor_merge (void)
   return !targetm.have_ctors_dtors || (optimize && in_lto_p);
 }
 
-struct ipa_opt_pass_d pass_ipa_cdtor_merge =
+class pass_ipa_cdtor_merge : public ipa_opt_pass_d
 {
- {
-  IPA_PASS,
-  "cdtor",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_ipa_cdtor_merge,			/* gate */
-  ipa_cdtor_merge,		        /* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_CGRAPHOPT,			        /* tv_id */
-  0,	                                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                                     /* todo_flags_finish */
- },
- NULL,				        /* generate_summary */
- NULL,					/* write_summary */
- NULL,					/* read_summary */
- NULL,					/* write_optimization_summary */
- NULL,					/* read_optimization_summary */
- NULL,					/* stmt_fixup */
- 0,					/* TODOs */
- NULL,			                /* function_transform */
- NULL					/* variable_transform */
-};
+public:
+  pass_ipa_cdtor_merge(context &ctxt)
+    : ipa_opt_pass_d(ctxt,
+		     "cdtor",
+		     OPTGROUP_NONE,
+		     TV_CGRAPHOPT,
+		     pass_properties(required(0),
+				     provided(0),
+				     destroyed(0)),
+		     pass_todo_flags(start(0),
+				     finish(0)),
+		     0) /* function_transform_todo_flags_start */
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_ipa_cdtor_merge (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return ipa_cdtor_merge (); }
+
+  /* ipa_opt_pass_d methods: */
+  bool has_generate_summary () { return false; }
+  void impl_generate_summary () { }
+
+  bool has_write_summary () { return false; }
+  void impl_write_summary () { }
+
+  bool has_read_summary () { return false; }
+  void impl_read_summary () { }
+
+  bool has_write_optimization_summary () { return false; }
+  void impl_write_optimization_summary () { }
+
+  bool has_read_optimization_summary () { return false; }
+  void impl_read_optimization_summary () { }
+
+  bool has_stmt_fixup () { return false; }
+  void impl_stmt_fixup (struct cgraph_node *, gimple *) { }
+
+  bool has_function_transform () { return false; }
+  unsigned int impl_function_transform (struct cgraph_node *) { return 0; }
+
+  bool has_variable_transform () { return false; }
+  void impl_variable_transform (struct varpool_node *) { }
+
+}; // class pass_ipa_cdtor_merge
+
+ipa_opt_pass_d *
+make_pass_ipa_cdtor_merge (context &ctxt)
+{
+  return new pass_ipa_cdtor_merge (ctxt);
+}
